<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Automatizace</title>
<style type="text/css">
    li { list-style: none;  margin: 0; }
    p { margin: 0; }

    span.l { color: red; font-weight: bold; }

    a.mapnode:link {text-decoration: none; color: black; }
    a.mapnode:visited {text-decoration: none; color: black; }
    a.mapnode:active {text-decoration: none; color: black; }
    a.mapnode:hover {text-decoration: none; color: black; background: #eeeee0; }

</style>
<!-- ^ Position is not set to relative / absolute here because of Mozilla -->
</head>
<body>
<p>Automatizace
<ul><li>motivace
<ul><li>Optimalizace v&#253;voje
<ul><li>Lep&#353;&#237; distribuce pr&#225;ce

</li>
<li>Release je dostupn&#253; ihned po testov&#225;n&#237;

</li>
<li>Znalost buildu je uchov&#225;na v pipeline
<ul><li>Ne u "nenahraditeln&#233;ho" zam&#283;stnance

</li>

</ul>
</li>
<li>Pipeline
<ul><li>R&#367;zn&#225; st&#225;dia v&#253;voje prob&#237;haj&#237; sou&#269;asn&#283;

</li>

</ul>
</li>

</ul>
</li>
<li>Kvalita
<ul><li>Dobr&#253; proces vynucuje kvalitu
<ul><li>Bezbolestn&#283;

</li>
<li>P&#345;ed samotn&#253;m k&#243;dov&#225;n&#237;m

</li>

</ul>
</li>
<li>Testy sou&#269;&#225;st&#237; procesu

</li>

</ul>
</li>
<li>Komfort
<ul><li>Chci programovat
<ul><li>Ne &#345;e&#353;it pro&#269; to zase nejde p&#345;elo&#382;it

</li>
<li>Ne to n&#283;kam uploadovat

</li>
<li>Ne &#269;ekat ne&#382; zkon&#269;&#237; code close

</li>

</ul>
</li>
<li>Aktu&#225;ln&#237; stav je dostupn&#253; v&#353;em
<ul><li>M&#367;&#382;u si to vyzkou&#353;et bez p&#345;ekladu

</li>
<li>M&#367;&#382;e si to vyzkou&#353;et kdokoliv

</li>

</ul>
</li>

</ul>
</li>

</ul>
</li>
<li>Gitflow
<ul><li>N&#225;vod
<ul><li>kam komitovat

</li>
<li>co testovat

</li>
<li>co kontrolovat

</li>
<li>kde hledat aktu&#225;ln&#237; prodku&#269;n&#237; verzi

</li>
<li>co d&#283;lat kdy&#382; se objev&#237; chyba

</li>

</ul>
</li>
<li>Stupe&#328; volnosti
<ul><li>V&#253;voj&#225;&#345;i tvo&#345;&#237; budoucnost

</li>
<li>Teste&#345;i testuj&#237; sou&#269;asnost

</li>
<li>Paralelismus
<ul><li>V&#253;roba
<ul><li>Ne&#269;ek&#225; a&#382; se to prod&#225;

</li>

</ul>
</li>
<li>Distribuce
<ul><li>Distribuje to co vyrobeno od minule

</li>

</ul>
</li>
<li>Prodejna
<ul><li>nen&#237; ovlivn&#283;na t&#237;m co se chyst&#225; v d&#237;ln&#283;.

</li>

</ul>
</li>

</ul>
</li>
<li>Izolovan&#225; pracovi&#353;t&#283;
<ul><li>Feature branche

</li>
<li>Nehotv&#225; feature neblokuje release
<ul><li>Nen&#237; sou&#269;&#225;st&#237; dod&#225;vky

</li>

</ul>
</li>

</ul>
</li>

</ul>
</li>
<li>Z&#225;vazek
<ul><li>Upstream
<ul><li>v&#283;t&#353;&#237; v&#253;znam ne&#382; jen centr&#225;ln&#237; &#250;lo&#382;i&#353;t&#283;

</li>
<li>Rozbiju to ostatn&#237;m

</li>

</ul>
</li>
<li>Merge request
<ul><li>conflict
<ul><li>Commit
<ul><li>Velikost

</li>
<li>Rozsah
<ul><li>V&#237;ce mal&#253;ch soubor&#367;
<ul><li>Git firendly

</li>

</ul>
</li>
<li>Velk&#253; soubor = conflict

</li>

</ul>
</li>

</ul>
</li>
<li>Pl&#225;novac&#237; jednotka

</li>

</ul>
</li>
<li>review

</li>

</ul>
</li>

</ul>
</li>

</ul>
</li>
<li>Testy
<ul><li>Process
<ul><li>Testy jsou sou&#269;&#225;st&#237; nejmen&#353;&#237; jednotky dod&#225;vky

</li>
<li>Dod&#225;vaj&#237; odvahu a jistotu

</li>
<li>Nut&#237; k zamy&#353;len&#237; nad slo&#382;itost&#237; k&#243;du
<ul><li>Modularita
<ul><li>Spu&#353;t&#283;n&#237; cel&#233;ho syst&#233;mu 

</li>
<li>Design component pro samostatn&#233; spu&#353;ten&#237;

</li>

</ul>
</li>
<li>Kdy&#382; je to moc t&#283;&#382;k&#233; na otestov&#225;n&#237;
<ul><li>&#352;patn&#225; dekompozice probl&#233;mu

</li>
<li>&#352;patn&#233; n&#225;vrhov&#233; vzory

</li>
<li>Moc v&#283;c&#237; v jednom

</li>

</ul>
</li>

</ul>
</li>
<li>Code quality jako test

</li>

</ul>
</li>
<li>spou&#353;t&#237; se b&#283;hem centr&#225;ln&#237;ho buildu

</li>
<li>Pokryt&#237; nesm&#237; klesnout

</li>

</ul>
</li>
<li>Review
<ul><li>Feature branch
<ul><li>Jasn&#283; patrn&#225; dod&#225;vka
<ul><li>Nen&#237; prolo&#382;ena ciz&#237;mi commity

</li>

</ul>
</li>
<li>Neotr&#225;v&#237; upstream

</li>
<li>Merge
<ul><li>Bez review nen&#237; merge

</li>
<li>Schv&#225;len&#237; &#382;e k&#243;d opravdu poputuje do v&#253;roby

</li>
<li>Jak se jednou k&#243;d zapoj&#237; do upstreamu, u&#382; se mus&#237; dod&#283;lat

</li>
<li>z&#225;vazek

</li>

</ul>
</li>

</ul>
</li>
<li>Mus&#237; b&#253;t kr&#225;tk&#233;
<ul><li>Feature branch mus&#237; b&#253;t "kr&#225;tk&#225;"

</li>
<li>Dlouh&#233; revie nikoho nebav&#237;
<ul><li>Ztr&#225;ta pozornosti

</li>
<li>&#352;patn&#225; dekompozice

</li>
<li>&#352;patn&#233; pl&#225;nov&#225;n&#237;

</li>

</ul>
</li>

</ul>
</li>
<li>Sd&#237;len&#237; znalost&#237;
<ul><li>Sd&#237;len&#237; zodpov&#283;dnosti

</li>
<li>Autobusov&#253; faktor

</li>

</ul>
</li>

</ul>
</li>
<li>CI/CD
<ul><li>Continuous Integration
<ul><li>Pr&#367;b&#283;&#382;n&#233; p&#345;id&#225;v&#225;n&#237; komponent

</li>
<li>Neaktivn&#237; k&#243;d
<ul><li>nic nerozbije

</li>
<li>nevol&#225; se

</li>
<li>M&#225; povahu knihovny

</li>

</ul>
</li>
<li>Ka&#382;d&#253; p&#345;idan&#253; kus mus&#237; po&#269;&#237;tat s produkc&#237;
<ul><li>S rollbackem

</li>
<li>S bezv&#253;padkov&#253;m p&#345;echodem

</li>
<li>S se soub&#283;hem se star&#353;&#237; verz&#237;

</li>

</ul>
</li>
<li>Uk&#225;zka rozpracovan&#233; funkctionality klientovi
<ul><li>V&#269;as odhal&#237; chyby v n&#225;vrhnu

</li>
<li>Nepochopen&#237; zad&#225;n&#237;

</li>

</ul>
</li>

</ul>
</li>
<li>Continuous Deployment

</li>

</ul>
</li>
<li>Deployment
<ul><li>Process
<ul><li>Pl&#225;nov&#225;n&#237; d&#237;l&#269;&#237;ch &#269;&#225;st&#237;

</li>
<li>Integrace do upstreamu

</li>
<li>Feature complete
<ul><li>Integrace do releasu

</li>

</ul>
</li>
<li>Testov&#225;n&#237;

</li>
<li>Nasazen&#237; do produkce

</li>

</ul>
</li>
<li>N&#225;stroje
<ul><li>gitlab
<ul><li>Pipelines
<ul><li>Docker
<ul><li>Stabiln&#237; prost&#345;ed&#237;

</li>
<li>pln&#225; volnost

</li>
<li>paralelismus verz&#237;

</li>

</ul>
</li>

</ul>
</li>

</ul>
</li>
<li>Jenkins
<ul><li>Pipelines

</li>
<li>&#344;et&#283;zen&#237; job&#367;

</li>

</ul>
</li>
<li>team city
<ul><li>Jako jenkins

</li>

</ul>
</li>

</ul>
</li>
<li>Infrastructure as a code
<ul><li>Konfigurace

</li>
<li>Zalo&#382;en&#237; infrastrukturn&#237;ho prvku

</li>
<li>Verzov&#225;n&#237; definic
<ul><li>gitflow

</li>
<li>CI/CD

</li>

</ul>
</li>

</ul>
</li>

</ul>
</li>

</ul></body>
</html>
